/**
 * 	All File System operations are maint to be in this file
 *  This means that no import of 'fs' module shouls apear elsewere
 *
 *  We also tries to use sync functions in order not to publish async functions
 *  for those basic stiff. It could be changed at any moment
 *  by using fs.promises...
 */
/// <reference types="node" />
import { TSData } from './tsdata';
export declare function $isfile(src: string | null | undefined): boolean;
export declare function $isexecutable(src: string | null | undefined): boolean;
export declare function $isdirectory(src: string | null | undefined): boolean;
export declare function $createDirectory(p: string | null | undefined): boolean;
export declare function $filesize(src: string | null | undefined): number;
export declare function $temporarypath(ext?: string | null | undefined, src?: string | null | undefined): string;
export declare function $uniquefile(src?: string | null | undefined, e?: string | null | undefined, internalImplementation?: boolean): string;
export declare function $isabsolutepath(src?: string | null | undefined, internalImplementation?: boolean): boolean;
export declare function $normalizepath(src?: string | null | undefined, internalImplementation?: boolean): string;
export declare function $path(first: string | boolean, ...paths: string[]): string;
export declare function $ext(s: string | null | undefined, internalImplementation?: boolean): string;
export declare function $withoutext(s: string | null | undefined, internalImplementation?: boolean): string;
export declare function $newext(s: string | null | undefined, e?: string | null | undefined, internalImplementation?: boolean): string;
export declare function $dir(s: string | null | undefined, internalImplementation?: boolean): string;
export declare function $filename(s: string | null | undefined, internalImplementation?: boolean): string;
export declare function $loadJSON(src: string | null | undefined | Buffer): any | null;
export declare function $readString(src: string | null | undefined, encoding?: BufferEncoding): string | null;
export declare function $writeString(src: string | null | undefined, str: string, encoding?: BufferEncoding): boolean;
export declare function $readBuffer(src: string | null | undefined): Buffer | null;
export declare function $readdata(src: string | null | undefined): TSData | null;
export declare function $writeBuffer(src: string | null | undefined, buf: TSData | Buffer | Uint8Array): boolean;
export declare function $removeFile(src: string | null | undefined): boolean;
export declare function $realMoveFile(src: string | null | undefined, dest: string | null | undefined): boolean;
export declare function $copyFile(src: string | null | undefined, dest: string | null | undefined, overwrite?: boolean): boolean;
